require "prefabutil"

local assets =
{
    Asset("ANIM", "anim/piggyback.zip"),
    Asset("ANIM", "anim/swap_piggyback.zip"),
}

local function OnOpen(inst)
    inst.sg:GoToState("open")
    inst.foleysound = "dontstarve/movement/foley/backpack"
end

local function OnClose(inst)
    inst.sg:GoToState("close")
    inst.foleysound = "dontstarve/movement/foley/backpack"
end

local function fn()

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
    MakeInventoryPhysics(inst)
    inst.AnimState:SetBank("piggyback")
    inst.AnimState:SetBuild("piggyback")
    inst.AnimState:PlayAnimation("anim")
    inst.MiniMapEntity:SetIcon("piggyback.png")
    inst.foleysound = "dontstarve/movement/foley/backpack"
    inst:AddTag("rabbit_hat")
	inst:AddTag("wildfireprotected")
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("inspectable")
    inst:AddComponent("tradable")
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "backpack_buckle_navy_phthalo"
    inst.components.inventoryitem.atlasname = "images/inventoryimages.xml"
	inst:AddComponent("container")
	inst.components.container:WidgetSetup("dragonflychest")
	inst:AddComponent("burnable")
    inst.components.burnable.canlight = false
    inst.components.burnable.fxprefab = nil
	
    MakeHauntableLaunch(inst)

    return inst
end

return  Prefab("rabbit_hatc", fn, assets)